#include "project.h"
#include "i2c_utils.h"
#include "hs3001.h"

#define HS3001_I2C_ADDRESS 0x44
uint8_t HS3001_i2c_address = HS3001_I2C_ADDRESS ;

int HS3001_Measurement_Request(void)
{
    int result = 0 ;
    i2c_set_slave_address(HS3001_i2c_address) ;    
    i2c_SendStart(0) ; /* 0 for write */
    i2c_SendStop() ;
    return( result ) ;
}

int HS3001_Data_Fetch(uint8_t data[])
{
    int result = 0 ;
    i2c_set_slave_address(HS3001_i2c_address) ;   
    i2c_SendStart(1) ; /* 1 for read */
    data[0] = i2c_readByte(I2C_I2C_ACK_DATA) ;
    data[1] = i2c_readByte(I2C_I2C_ACK_DATA) ;
    data[2] = i2c_readByte(I2C_I2C_ACK_DATA) ;
    data[3] = i2c_readByte(I2C_I2C_NAK_DATA) ;
    i2c_SendStop() ;
    return( result ) ;
}

int HS3001_Hume_Fetch(float *hume) 
{
    int result = 0 ;
    uint8_t data[2] ;
    i2c_set_slave_address(HS3001_i2c_address) ;   
    i2c_SendStart(1) ; /* 1 for read */
    data[0] = i2c_readByte(I2C_I2C_ACK_DATA) ;
    data[1] = i2c_readByte(I2C_I2C_NAK_DATA) ;
    i2c_SendStop() ;
    *hume  = 100.0 * (((data[0] & 0x3F) << 8) | data[1]) / 16383.0 ;
    return( result ) ;
}  